import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

RaceTrack = class();

function RaceTrack:Constructor(size, margin)
	self.size = size;
	self.margin = margin;
	self:clear();
end

function RaceTrack:place(y, lane)
	local i;

	if lane == nil then
		for i = 1, #self.track, 1 do
			if self.track[i] >= y then
				lane = i;
				break;
			end
		end
	end

	if lane == nil or lane > #self.track then
		lane = #self.track + 1;
	end
	self.track[lane] = y - self.size - self.margin;
	return lane;
end

function RaceTrack:find(y, pref)
	local i, r, b, s;

	r = #self.track + 1;
	b = -math.huge;

	for i = 1, #self.track, 1 do
		if self.track[i] >= y then
			if pref[i] > b then
				r = i;
				b = pref[i];
			end
		end
	end

	return r;
end

function RaceTrack:clear()
	self.track = { };
end

function RaceTrack:set(lanes)
	self.track = { };

	for i = 1, lanes, 1 do
		self.track[i] = math.huge;
	end
end